import { Component, Input, Output, EventEmitter } from '@angular/core';
import { DeliveryOption } from '../../services/preference/preference';
var DeliveryoptionsComponent = /** @class */ (function () {
    function DeliveryoptionsComponent() {
        this.save = new EventEmitter();
        this.newDeliveryOption = new DeliveryOption();
        this.adding = false;
    }
    DeliveryoptionsComponent.prototype.ngOnInit = function () {
    };
    DeliveryoptionsComponent.prototype.addDeliveryOption = function () {
        var emailPattern = /^\w+@[a-zA-Z_]+?\.[a-zA-Z]{2,3}$/;
        if (emailPattern.test(this.newDeliveryOption.value)) {
            this.newDeliveryOption.deliveryType = 'email';
        }
        var phonePattern = /^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{4,6}$/im;
        if (phonePattern.test(this.newDeliveryOption.value)) {
            this.newDeliveryOption.deliveryType = 'text';
        }
        var count = this.customerPreference.deliveryOptions.length;
        this.newDeliveryOption.id = count === 0 ? 1 : this.customerPreference.deliveryOptions[count - 1].id + 1;
        this.newDeliveryOption.status = 'notVerified';
        this.customerPreference.deliveryOptions.push(this.newDeliveryOption);
        this.cancelDeliveryOption();
        this.save.emit(null);
    };
    DeliveryoptionsComponent.prototype.cancelDeliveryOption = function () {
        this.adding = false;
        this.newDeliveryOption = new DeliveryOption();
    };
    DeliveryoptionsComponent.prototype.deleteDeliveryOption = function (deliveryOption) {
        // remove from list of delivery options
        this.customerPreference.deliveryOptions.splice(this.customerPreference.deliveryOptions.indexOf(deliveryOption), 1);
        // Remove from any preference records that reference it
        for (var _i = 0, _a = this.customerPreference.alertPreferences; _i < _a.length; _i++) {
            var pref = _a[_i];
            pref.deliverTo.splice(pref.deliverTo.indexOf(deliveryOption.id), 1);
        }
        this.save.emit(null);
    };
    DeliveryoptionsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'np-deliveryoptions',
                    template: "\n    <h4>Delivery options</h4>\n    <div *ngFor=\"let option of this.customerPreference.deliveryOptions\">\n        <svg *ngIf=\"option.deliveryType =='text'\" class=\"np-icon\"><use xlink:href=\"#chat\" /></svg>\n        <svg *ngIf=\"option.deliveryType =='email'\" class=\"np-icon\"><use xlink:href=\"#email\" /></svg>\n      {{option.name}} ({{option.value}})\n      <span (click)=\"deleteDeliveryOption(option)\" class=\"np-close\"></span>\n    </div>\n    <button *ngIf=\"!adding\" class=\"np-button\" (click)=\"adding=true\">New Delivery Option</button>\n    <div *ngIf=\"adding\">\n        <p class=\"np-section\">Enter an email address or mobile phone number:</p>\n        <input [(ngModel)]=\"newDeliveryOption.value\" placeholder=\"email or mobile number\" />\n        <input [(ngModel)]=\"newDeliveryOption.name\" placeholder=\"Nickname (optional)\" />\n        <span>\n          <button class=\"np-button\" (click)=\"addDeliveryOption()\">Save</button>\n          <button class=\"np-button\" (click)=\"cancelDeliveryOption()\">Cancel</button>\n        </span>\n    </div>\n  ",
                    styles: ["\n    .np-icon{width:16px;height:13px}\n  "]
                },] },
    ];
    /** @nocollapse */
    DeliveryoptionsComponent.ctorParameters = function () { return []; };
    DeliveryoptionsComponent.propDecorators = {
        'customerPreference': [{ type: Input },],
        'save': [{ type: Output },],
    };
    return DeliveryoptionsComponent;
}());
export { DeliveryoptionsComponent };
//# sourceMappingURL=deliveryoptions.component.js.map